unit iLanguage;
{
version 3
     ,         .
}

interface

uses IniFiles, SysUtils, Dialogs, Forms, Classes,
  kuModul,
  kuY,
  kuLanguageUni;

procedure Lng_Translate_Vars(Path: string);
procedure Lng_Translate_Form1;
procedure Lng_SETUP(const Lng_Path: string; ShowInfo: Boolean = false);

var


{$REGION '   Words   '}


_File                  : String = 'File';
_File_Open             : String = 'Open';
_File_New              : String = 'New';
_File_Save             : String = 'Save';
_File_SaveAs           : String = 'Save As';
_File_Recent           : String = 'Recent';
_File_NotExist         : String = 'file not exist';
_File_isCreated        : String = 'File of Katalog is created:';
_File_isSaved          : String = 'Katalog is saved';
_File_isImported       : String = 'Katalog is imported good';
_File_XLisImported     : String = 'Excel file is imported!';
_File_MustBe           : String = 'Please, create new kat-file or open exist.'+#13#10+ 'After that you can import Excel!';
_File_DragDropCanFiles	: String = 'Can drop only *.kat  *.xls files';
_File_DragDropCan1      : String = 'Can drop only one file';
_File_Open_Q            : String = 'Do you want to open it now?';
_File_SaveChanges_Q     : String = 'Save changes in current katalog ?';
_File_Info             : String = 'File info';
_File_Ext_             : String = 'kat';
_File_pExt_            : String = '.kat';
_File_Filter_New_      : String = 'Katalog (*.kat)|*.*|';
_File_Filter_Open_     : String = 'Katalog (*.kat)|*.kat|';
_File_Filter_All       : String = 'All files (*.*)|*.*|';


_Set                  : string = 'Settings';
_Set_Numeration       : string = 'Numeration';
_Set_AbsentOnly       : string = 'Absent Only';
_Set_PanelBtn         : string = 'Panel button';
_Set_AutoOpenLastFile : string = 'Auto open last file';
_Set_AutoStart       : string = 'Autostart program with OS';
_Set_RunMinimized    : string = 'Run Program minimized to Tray';
_Set_OnRestoreIcon   : string = 'OnRestoreForm Icon in:';
_Set_General         : string = 'General';
_Set_HotKeys         : string = 'HotKeys';
_Set_YouCanDragLng   : string = 'You can drag and drop lng file into this window';
_Set_CloseToTray     : string = 'Close to Tray';


{$ENDREGION}


implementation


uses //       
Main,
Settings;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ind Word Translate
procedure Lng_Translate_indWords(ini: TStringList);
//       
begin

//File
Lng_Translate_Word(ini, _File,                  'File'                          );
Lng_Translate_Word(ini, _File_Open,             'File_Open'                     );
Lng_Translate_Word(ini, _File_New,              'File_New'                      );
Lng_Translate_Word(ini, _File_Save,             'File_Save'                     );
Lng_Translate_Word(ini, _File_SaveAs,           'File_SaveAs'                   );
Lng_Translate_Word(ini, _File_Recent,           'File_Recent'                   );
Lng_Translate_Word(ini, _File_isCreated,        'File_isCreated'                );
Lng_Translate_Word(ini, _File_isSaved,          'File_isSaved'                  );
Lng_Translate_Word(ini, _File_isImported,       'File_isImported'               );
Lng_Translate_Word(ini, _File_Open_Q,           'File_Open_Q'                   );
Lng_Translate_Word(ini, _File_SaveChanges_Q,    'File_SaveChanges_Q'            );
Lng_Translate_Word(ini, _File_Info,             'File_Info'                     );

//Set
Lng_Translate_Word(ini, _Set,                  'Set'                    );
Lng_Translate_Word(ini, _Set_AutoOpenLastFile, 'Set_AutoOpenLastFile'   );
Lng_Translate_Word(ini, _Set_AutoStart,        'Set_AutoStart'          );
Lng_Translate_Word(ini, _Set_RunMinimized,     'Set_RunMinimized'       );
Lng_Translate_Word(ini, _Set_YouCanDragLng,    'Set_YouCanDragLng'      );
Lng_Translate_Word(ini, _Set_CloseToTray,      'Set_CloseToTray'        );


end;




//LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL Vars
procedure Lng_Translate_Vars(Path: string);
{
     .
    ?
    :
  1)         OnCreate
  2)     ,   

       Caption          
}

var ini : TStringList;
begin
  
ini            := TStringList.Create;
ini.Text       := ANSItoUTF8(ini.Text);
ini.WriteBOM   := True;
ini.LoadFromFile(Path);

Strs_SectionDelete('Untranslated', ini);

Lng_Translate_indWords(ini);
Lng_Translate_uniWords(ini);

ini.SaveToFile(Path);
ini.Free;

end;





{$REGION '   Form   '}



//LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL Form1
procedure Lng_Translate_Form1;
//           

var i : integer;
begin with Form1 do begin


//Program
MM.ActionControls[0].Caption := _Program;
MM.ActionControls[0].Width := 25;
Act_Program_About.Caption   := _Program_About;
Act_Program_OpenInExplorer.Caption := _OpenInExplorer;
Act_Program_Mail.Caption    := _Program_Mail;
Act_Program_Sait.Caption    := _Program_Sait;
Act_Program_Help.Caption    := _Program_Help;
Act_Program_FullScreen.Caption  := _FullScreen;
Act_Program_Maximize.Caption  := _Maximize;
//Act_Program_Minimize.Caption  := _Minimize;
Act_Program_MinimizeToTray.Caption  := _MinimizeToTray;
Act_Program_Close.Caption     := _Close;
Act_Program_About.Hint   := _Program_About;
Act_Program_Mail.Hint    := _Program_Mail;



//File
MM.ActionControls[1].Caption := _File;
Act_File_New.Caption := _File_New;
Act_File_Open.Caption := _File_Open;
Act_File_Save.Caption := _File_Save;
Act_File_SaveAs.Caption := _File_SaveAs;
Act_File_Import.Caption := _Import;
Act_File_Export.Caption := _Export;
Act_File_Close.Caption := _Close;
Act_File_OpenInExplorer.Caption := _OpenInExplorer;
Act_File_Recent_SUB.Caption := _File_Recent;
Act_File_Inf.Caption := _File_Info;

Act_File_New.Hint := _New;
Act_File_Open.Hint := _Open;
Act_File_Save.Hint := _Save;
Act_File_Import.Hint := _Import;
Act_File_Export.Hint := _Export;
Act_File_Close.Hint := _Close;
Act_File_OpenInExplorer.Hint := _OpenInExplorer;
Act_File_Inf.Hint := _File_Info;


//Set
//MMM.ActionControls[5].Caption := _Set;
Act_Set_Settings.Caption := _Set;
Act_Set_Settings.Hint := _Set;
Act_Set_Lng.Caption := _Lng;
Act_Set_AutoOpenLastFile.Caption := _Set_AutoOpenLastFile;
Act_Set_Autostart.Caption := _Set_Autostart;
Act_Set_RunMinimizedToTray.Caption := _Set_RunMinimized;
Act_Set_CloseToTray.Caption := _Set_CloseToTray;



MM_Widths(MM);



end;end;



//LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL FormSet
procedure Lng_Translate_FormSet;
begin with FormSettings do begin


FormSettings.Caption := _Set;
tab_General.Caption := _Set_General;
tab_HotKeys.Caption := _Set_HotKeys;
lab_OnRestoreIcon.Caption := _Set_OnRestoreIcon;
lab_YouCanDragLng.Caption := _Set_YouCanDragLng;


end;end;



//LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL Forms
procedure Lng_Translate_Forms;
begin
Lng_Translate_Form1;
Lng_Translate_FormSet;
end;



{$ENDREGION}





//LLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLLL Setup
procedure Lng_SETUP(const Lng_Path: string; ShowInfo: Boolean = false);
var
ini : TIniFile;
s: string;

//PathNewCopy : string;

begin


//    ,     
if not FileExists(Lng_Path)
then
begin
   ShowMessage(_Lng_FileAbsent +AZ+AZ+ _Lng_Path);
   exit;
end;


//       
//    PathNewCopy := ExtractFilePath(Application.ExeName) + ExtractFileName(Lng_FilePath);
//
//    if Form_Settings.ch_CopyLanguage.Checked
//    then
//    begin
//        YY('FormSettings.ch_CopyLanguage.Checked = true');
//        if AnsiUpperCase(Lng_FilePath) <> AnsiUpperCase(PathNewCopy)
//        then
//        begin
//            YY(Lng_FilePath + AZ+ PathNewCopy + AZ+'diff ---> copy');
//            if FileExists(PathNewCopy) then DeleteFile(PathNewCopy);
//            if CopyFile(PChar(Lng_FilePath), PChar(PathNewCopy), True)
//            then _Lng_Path := PathNewCopy;
//        end;
//    end;
//
//y_(Path_Full_to_PRO(FullPath));



s := Path_FullToApp(Lng_Path);


if _Lng_Path <> Lng_Path
then
begin
    _Lng_Path := Lng_Path;

    ini := TiniFile.Create( Path_App + 'settings.ini' );
    ini.WriteString ( 'Settings', 'Language', s );
    ini.Free;
end;

Lng_Translate_Vars(_Lng_Path);
Lng_Translate_Forms;


if Application.FindComponent('FormSettings') <> nil then FormSettings.edt_Lng.Text := s;

//     
if ShowInfo then YY(_Lng_Setuped);
  
end;




end.
