unit kuLabelLink;
{
    .
: 2018.2
:  
http://kuzduk.000webhostapp.com


Font -    

FontHover -    

Link -       ,
 , ,   ,
         , :
D:\
file://
http://
https://
mailto:
news:
telnet:

   kuLabelLink1       Link (  TkuLabelLink.Click)
   OnClick     ,     Link  :     OnClick

Link    ( %exe),         Path_RelativToFull

kuLabelLink   PopumMenu  :        .    PopumMenu

      kuLabelLink,  Link    
}

interface

uses
  Windows, Messages, Classes, Graphics, Controls, Forms, StdCtrls,
  ShellApi, Clipbrd, Menus, Dialogs, kuModul, kuShell;


type

  TkuLabelLinkAutoPopupMenu = class(Menus.TPopupMenu)

  public
    procedure Popup(X, Y: Integer); override;

  end;


  TkuLabelLink = class(TLabel)

  private
    fLink: string;
    fLinkForCopy: string;
    fFontHover: TFont;
    fmb: TMouseButton;

    procedure pmCopyLinkToClipboard(Sender: TObject);
    procedure pmExecute(Sender: TObject);
    procedure SetLink(Value: string);
    procedure SetLinkForCopy(Value: string);
    procedure SetFontHover(Value: TFont);

  protected
    fpmPopuped: Boolean;
    fFontLeave: TFont;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
    procedure MouseEnter(var message: TMessage); message CM_MOUSEENTER;
    procedure MouseLeave(var message: TMessage); message CM_MOUSELEAVE;

  public
    procedure ExecuteLink;
    procedure CopyLinkToClipboard;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;

  published
    property Link: string read fLink write SetLink;
    property LinkForCopy: string read fLinkForCopy write SetLinkForCopy;
    property FontHover: TFont read fFontHover write SetFontHover;

  end;

procedure Register;

var

_Link_Execute         : string = 'Execute link';
_Link_CopyToClipboard : string = 'Copy link to clipboard';




implementation

//------------------------------------------------------------------------------ register component
procedure Register;
begin
  RegisterComponents(_kuKomponentsPaletteKategory, [TkuLabelLink]);
end;






//============================================================================== Create
constructor TkuLabelLink.Create(AOwner: TComponent);
begin

inherited;

Cursor := crhandPoint;
ShowAccelChar := False;


Font.Style := Font.Style + [fsUnderline];
Font.Color := clBlue;

fFontLeave := TFont.Create;
fFontLeave.Assign(Font);

fFontHover := TFont.Create;
fFontHover.Assign(FontHover);
fFontHover.Color := $00C6C600; //
//fFontHover.Color := $00FF8080; // 
//fFontHover.Color := $00FF8000; //  

end;


//============================================================================== Destroy
destructor TkuLabelLink.Destroy;
begin

inherited;

fFontHover.Free;
fFontLeave.Free;

end;






//------------------------------------------------------------------------------ Copy Link To Clipboard
procedure TkuLabelLink.CopyLinkToClipboard;
begin

if fLinkForCopy <> ''
then Clipboard.AsText := fLinkForCopy
else Clipboard.AsText := fLink;

end;



//------------------------------------------------------------------------------ Execute
procedure TkuLabelLink.ExecuteLink;
begin
Link_Execute(fLink);
end;





{$REGION ' mouse '}


//------------------------------------------------------------------------------ Mouse Enter (Hover)
procedure TkuLabelLink.MouseEnter(var message: TMessage);
begin

fFontLeave.Assign(Font); //  

Font.Assign(fFontHover);

//    FontHover   Design-Time
//if (csDesigning in ComponentState) and (TControl(message.LParam).ClassName = Self.ClassName) then Repaint;

end;


//------------------------------------------------------------------------------ Mouse Leave
procedure TkuLabelLink.MouseLeave(var message: TMessage);
begin

if fpmPopuped
then
begin
   Font.Assign(fFontHover);
//   Application.MainForm.Caption := Application.MainForm.Caption + 'L';
   exit;
end;


Font.Assign(fFontLeave);

end;





//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Mouse Down
procedure TkuLabelLink.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin

fmb  := button;

inherited;

end;



//------------------------------------------------------------------------------ Mouse Up
procedure TkuLabelLink.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  mi: TMenuItem;

begin

case Button of

  mbMiddle: Self.CopyLinkToClipboard;

  mbRight:
      begin
          if (Self.PopupMenu = nil) and (fmb = mbRight)

          then
          begin
              Self.PopupMenu := TkuLabelLinkAutoPopupMenu.Create(Self);

//              mi := TMenuItem.Create(Self.PopupMenu);
//              Self.PopupMenu.Items.Add(mi);
//              mi.Caption := _Link_Execute;
//              mi.OnClick := pmExecute;


              mi := TMenuItem.Create(Self.PopupMenu);
              Self.PopupMenu.Items.Add(mi);
              mi.Caption := _Link_CopyToClipboard;
              mi.OnClick := pmCopyLinkToClipboard;
          end

          else
          begin
//              if Self.PopupMenu.ClassName = 'TPopupMenu' then
//              begin
//                  tku := TkuPopupMenu.Create(Application);
//                  tc := TComponent.Create(Application);
//                  tku.Items.Assign(Self.PopupMenu.Items);
//                  tku := Tkupopupmenu(Self.PopupMenu);

//                  tku.Popup(0,0);

//                  Self.PopupMenu :=  TkuPopupMenu.Create(Self);

//                    TClass(pointer(PopupMenu)^) := TkuPopupMenu;//      
//                    Application.MainForm.Caption := Application.MainForm.Caption + 'ZU';
//                  Self.PopupMenu.Free;
//                  Self.PopupMenu.Create := tku;
//              end;
          end;
      end;
end;

inherited;


end;





//------------------------------------------------------------------------------ Click
procedure TkuLabelLink.Click;
begin

inherited;

if @self.OnClick <> nil then exit; //  OnClick       



// :
Self.ExecuteLink;

end;




{$ENDREGION}






{$REGION ' private '}




//------------------------------------------------------------------------------ pm Execute (Sender)
procedure TkuLabelLink.pmExecute(Sender: TObject);
begin
Self.ExecuteLink;
end;


//------------------------------------------------------------------------------ pm Copy Link To Clipboard (Sender)
procedure TkuLabelLink.pmCopyLinkToClipboard(Sender: TObject);
begin
Self.CopyLinkToClipboard;
end;






//------------------------------------------------------------------------------ set Link
procedure TkuLabelLink.SetLink(Value: string);
begin
fLink := Value;
end;



//------------------------------------------------------------------------------ set Link for Copy
procedure TkuLabelLink.SetLinkForCopy(Value: string);
begin
fLinkForCopy := Value;
end;




//------------------------------------------------------------------------------ set FontHover
procedure TkuLabelLink.SetFontHover(Value: TFont);
begin
fFontHover.Assign(Value);
end;






{$ENDREGION}






//------------------------------------------------------------------------------ popup
procedure TkuLabelLinkAutoPopupMenu.Popup(X, Y: Integer);
begin

TkuLabelLink(Self.Owner).fpmPopuped := true;

//    popup
inherited;
//    popup,   pmClose:

TkuLabelLink(Self.Owner).fpmPopuped := false;

TkuLabelLink(Self.Owner).Font.Assign(TkuLabelLink(Self.Owner).fFontLeave);

end;






end.
