unit kuShellListView;
{
 2018.12
    ,  TShellListView,       Delphi 7

:  
kuzduk@mail.ru
kuzduk.000webhostapp.com

   :

F2 - 
F5 - 
F6 -  txt
F7 -  
Del - 
Back -   

Ctrl + Back -  " "
Alt + D -  " "
Alt + Q -  ""

Ctrl +  -   
Ctrl + X -   
Ctrl + V -   

Alt + O -    ( )
Alt + C -   
Alt + V -      
Ctrl+ Shift + C -       
Ctrl+ Alt + C -      

Ctrl + A -   (All)
Ctrl + Shift + A -   (Invert)
Ctrl + D -   (Deselect)

Ctrl + 1 -   
Ctrl + 2 -   
Ctrl + 3 -   

 +    -   
Ctrl + ` -   
Ctrl + H -   


:
Telo -  ,   
TeloName -     /    
TeloID - File.ext, Folder.*dir, Link.lnk

:
Path -   
PathRoot - root-    :    ,        

ShowElements -  :  /  /   
ShowHide -   
ClearView -     

Drag & Drop  -               
}


interface

uses Windows, Messages, SysUtils, Controls, Classes, ComCtrls, Graphics,
     iniFiles, ShellApi, ClipBrd, StdCtrls,

     kuY,
     kuYN,
     kuRenamer,
     kuLanguageUni,
     kuModul,
     kuShell,
     kuIconize,
     kuDrag,
     kuDrop;



type
  TDropEvent = procedure(Sender: TObject) of object;
  TPathChangeEvent = procedure(Sender: TObject; OldPath, NewPath: string; var CanChange: Boolean) of object;
  TPathChangedEvent = procedure(Sender: TObject; NewPath: string) of object;
  TStyleChangeEvent = procedure(Style: TViewStyle) of object;
  TShowElements = (seAll, seFiles, seFolders);

  TkuShellListView = class(TListView)

    private
//      fColoredEvenItems: Boolean;
      fClearView: Boolean;
      fDirUpItem: Boolean;
      fExecuteFile: Boolean;
      fPathRoot: string;
      fImageList1: TImageList;
      fImageList2: TImageList;
      fIsRMDowm: Boolean;
      fOnDrop: TDropEvent;
      fOnPathChange: TPathChangeEvent;
      fOnPathChanged: TPathChangedEvent;
      fOnStyleChange: TStyleChangeEvent;
      fPath: string;
      fSortNap: integer;
      fSortCol: integer;
      fShowHide: Boolean;
      fShowElements: TShowElements;
      hWheelis: Boolean;

      fKuDrop_LVS: TkuDrop;
      procedure OnDrop_LVS(Sender: TObject);

      procedure WMMOUSEWHEEL(Var Msg: TWMMOUSEWHEEL); message WM_MOUSEWHEEL;
      procedure MOUSE_R_DOWN(Var Msg: TMessage); message WM_RBUTTONDOWN;
      procedure MOUSE_L_DOWN(Var Msg: TMessage); message WM_LBUTTONDOWN;

    protected
      procedure SetClearView(Value: Boolean);
      procedure SetColoredEvenItems(Value: Boolean);
      procedure SetDirUpItem(Value: Boolean);
      procedure SetExecuteFile(Value: Boolean);
      procedure SetPathRoot(Value: string);
      procedure SetPath(Value: string);
      procedure SetShowHide(Value: Boolean);
      procedure SetShowElements(Value: TShowElements);

    public
      qSelectedList: TStrings;

      constructor Create(AOwner: TComponent); override;
      procedure Loaded; override;
      destructor Destroy; override;

      procedure ColClick(Column: TListColumn); override;
      procedure CopyData;
      procedure CreateNewFolder;
      procedure CreateNewTxt;
      function  CustomDrawItem(Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage): Boolean; virtual;
      procedure CutData;
      procedure DblClick; override;
      procedure DeleteSelected; override;
      procedure DeselectAll;
      procedure DirUp;
      procedure Execute;
      function  FindTeloID(TeloID: string): TListItem;
      procedure iniLoad(SectionName: string = ''; LoadPath: Boolean = False);
      procedure iniSave(const SectionName: string);
      procedure KeyDown(var Key: Word; Shift: TShiftState); override;
      procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
      procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
      procedure Info;
      procedure OpenInExplorer;
      procedure PasteData;
      function  PostRootPath: string;
      procedure Reload;
      procedure Rename;
      procedure SelectInvers;
      procedure SelectedList  (Strs: TStrings; AddFullPath: string = '');
      procedure SelectedListID(Strs: TStrings; AddFullPath: string = '');
      procedure SetViewStyle(Value: TViewStyle); override;
      procedure Sort; overload;
      procedure Sort(SortCol, SortNap: integer); overload;
      procedure StyleNext;
      procedure StylePrev;
      function  TeloID  (Index: integer; AddFullPath: string = ''): string;
      function  TeloNameI(Item: TListItem; AddFullPath: string = ''): string; //overload;
      function  TeloName(Index: integer; AddFullPath: string = ''): string; //overload;
      function  TeloNameB(Item: TListItem; AddFullPath: Boolean): string; //overload;

      property SortCol: Integer read fSortCol;
      property SortNap: Integer read fSortNap;

    published
//      property ColoredEvenItems: Boolean read fColoredEvenItems write SetColoredEvenItems default True;
      property ClearView: Boolean read fClearView write SetClearView default False;
      property DirUpItem: Boolean read fDirUpItem write SetDirUpItem;// default Flase;
      property ExecuteFile: Boolean read fExecuteFile write SetExecuteFile default True; //Execute File OnDblClick and Enter
      property PathRoot: string read fPathRoot write SetPathRoot;
      property OnDrop: TDropEvent read fOnDrop write fOnDrop;
      property OnPathChange: TPathChangeEvent read fOnPathChange write fOnPathChange;
      property OnPathChanged: TPathChangedEvent read fOnPathChanged write fOnPathChanged;
      property OnStyleChange: TStyleChangeEvent read fOnStyleChange write fOnStyleChange;
      property Path: string read fPath write SetPath;// default Dpath;
      property ShowElements: TShowElements read fShowElements write SetShowElements default seAll;
      property ShowHide: Boolean read fShowHide write SetShowHide default False;

//      property LoadedDrives: Array;
//      property FileFilterShow: string;
//      property FileFilterNotShow: string;

  end;



procedure Register;

procedure LV_LoadRoot(LV: TListView; ReadOnlyDrives: Boolean = False);
function  LV_LoadDir(LV: TListView; Dir: string; HideShow: Boolean; ShowType: TShowElements): Boolean;
function  LV_Load(LV: TListView; Dir: string; HideShow: Boolean; ShowType: TShowElements): string;
function  LV_StyleToInt(LV: TListView): integer;
procedure LV_ColoredEvenItems(LV: TListView; Item: TListItem; EvenColor: TColor = -1);

function  LVS_DIR_EXT: string;
function  LVS_isFolder(ext: string): Boolean; overload;
function LVS_isFolder(Item: TListItem): Boolean; overload;

procedure Adres_Enter(Adres: TEdit; LVS: TkuShellListView);
function  kuDirectoryExists(Path: string; var PathReform: string; CanRoot: Boolean = True): Boolean;

// 
procedure LVS_RefreshIconss(LV: TListView; Dir: string);



const
  _LVS_DIR_SIZE = '---';   //     
  _LVS_DIR_EXTID = '*dir'; //    TeloID
  _LVS_DIR_EXT_PREFIX = '\'; //  "".  ,     ,   _LVS_DIR_EXT_POSTFIX  

  cl_5 :TColor = $F3F3F3;


var

  _LVS_DIR_EXT_POSTFIX  : string = 'Folder'; //  ""  

  _lvs_NewFolderName    : string = 'New Folder';
  _lvs_CreateNewFolder  : string = 'Create folder';
  _lvs_CreateNewTxt     : string = 'Create txt file';
  _lvs_DirAlreadyExist  : string = 'Can not to create folder because folder with such name already exists';
  _lvs_DirCanNotCreate  : string = 'Can not to create new folder :(';
  _lvs_ShowHide         : string = 'Show hide files and filders';
  _lvs_Dir_Up           : string = 'Up directory';

  _LV_Style       : string = 'Style';
  _LV_StyleTable  : string = 'Table';
  _LV_StyleIcons  : string = 'Icons';
  _LV_StyleCols   : string = 'Cols';
  _LV_StyleRows   : string = 'Rows';

//  _LVS_History : TStringList;
//  _LVS_HistoryIndex: integer = 0;
//  _LVS_HistoryBegin: integer = 0;
//  _LVS_HistoryEnd:   integer = 99;





implementation


procedure Register;
begin
  RegisterComponents(_kuKomponentsPaletteKategory, [TkuShellListView]);
end;




{$REGION '   LV   '}



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Create
constructor TkuShellListView.Create(AOwner: TComponent);
begin

inherited;

Self.Columns.Add;
Self.Columns.Add;
Self.Columns.Add;
Self.Columns.Add;

Self.MultiSelect := True;
Self.RowSelect := True;
Self.ReadOnly := True;
Self.ExecuteFile := True;
Self.IconOptions.AutoArrange := True;


Self.Column[0].Width := 200;
Self.Column[1].Width := 80;
Self.Column[2].Width := 80;
//Self.Column[3]. := 80;



fImageList1 := TImageList.Create(Self);
fImageList2 := TImageList.Create(Self);

Self.SmallImages := fImageList1;
Self.LargeImages := fImageList2;

qSelectedList := TStringList.Create;

fSortNap := 1;
fSortCol := 1;

//Self.Path := ''; //   IDE !! 
//fPath := LV_Load(Self, '', fShowHide, fShowElements);
//Self.Color := clRed;

end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Loaded
procedure TkuShellListView.Loaded;
begin
fkuDrop_LVS := TkuDrop.Create(Self);
fkuDrop_LVS.OnDropFiles := Self.OnDrop_LVS; //  

Self.Columns.Items[2].Alignment := taRightJustify; //     
end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Destroy
destructor TkuShellListView.Destroy;
begin

fkuDrop_LVS.Free;

inherited;

qSelectedList.Free;

end;



//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Custom Draw
function TkuShellListView.CustomDrawItem(Item: TListItem; State: TCustomDrawState; Stage: TCustomDrawStage): Boolean;
begin

//inherited;

LV_ColoredEvenItems(Self, Item);

end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH Key Down (Hot Keys)
procedure TkuShellListView.KeyDown(var Key: Word; Shift: TShiftState);
var
s, t: string;
i: integer;

begin

case Key
of



//Enter
13: Self.Execute;



//BackSpace
VK_BACK:  if ssCtrl in Shift
          then Self.Path := ''
          else Self.DirUp;


//Delete
VK_DELETE: Self.DeleteSelected;



//F1
VK_F1:
    //Ctrl + F1
    if ssCtrl in Shift then Self.Info;



//F2
VK_F2: Self.Rename;


//F5
VK_F5: Self.Reload;


//F6
VK_F6: Self.CreateNewTxt;


//F7
VK_F7: Self.CreateNewFolder;










67:
begin
    //Ctrl + C
    if ssCtrl in Shift then Self.CopyData;

    //Alt + C
    if ssAlt in Shift then Clipboard.AsText := fPath;

    //Ctrl + Shift + C
    if (ssCtrl in Shift) and (ssShift in Shift)
    then
    begin
        Self.SelectedList(qSelectedList, fPath);
        Clipboard.AsText := qSelectedList.Text;
    end;

    //Ctrl + Alt + C
    if (ssCtrl in Shift) and (ssAlt in Shift)
    then
    begin
        Self.SelectedList(qSelectedList);
        Clipboard.AsText := qSelectedList.Text;
    end;

end;



//Ctrl + X
88: if ssCtrl in Shift then Self.CutData;




79: //O
begin
  //Alt + O
  if ssAlt in Shift
  then
  begin
      Self.OpenInExplorer;
  end;

end;




86:
begin
  //Alt + V
  if ssAlt in Shift
  then
  begin
     s := Clipboard_GetPath1;

     if FileExists(s)
     then s := Path_DirUp(s, t);

     Self.Path := s;
  end;

  //Ctrl + V
  if fPath <> '' then
    if ssCtrl in Shift
    then Self.PasteData
end;



//A
65:
  begin
    //Ctrl + Shift +  A
    if (ssCtrl in Shift) and (ssShift in Shift) then Self.SelectInvers

    else

    //Ctrl + A
    if ssCtrl in Shift then Self.SelectAll;
  end;




//D
68:
begin
    //Ctrl + D
    if ssCtrl in Shift then Self.DeselectAll;

    //Alt + D
    if ssAlt in Shift then Self.Path := Path_Desktop;
end;



//Q
81: if ssAlt in Shift then Self.Path := Path_App;



//i
//73:



//Ctrl + ` (Style)
192: if ssCtrl in Shift then Self.StyleNext;



//Ctrl + H
72: if ssCtrl in Shift then Self.ShowHide := not Self.ShowHide;



//Ctrl + 1
49: if ssCtrl in Shift
   then
   begin
      if SortCol = 0

      then
      begin
        fSortNap := -fSortNap;
      end

      else
      begin
        fSortNap := 1;
        fSortCol := 0;
      end;

      Self.Sort;
   end;


//Ctrl + 2
50: if ssCtrl in Shift
   then
   begin
      if SortCol = 1

      then
      begin
        fSortNap := -fSortNap;
      end

      else
      begin
        fSortNap := 1;
        fSortCol := 1;
      end;

      Self.Sort;
   end;


//Ctrl + 3
51: if ssCtrl in Shift
   then
   begin
      if SortCol = 2

      then
      begin
        fSortNap := -fSortNap;
      end

      else
      begin
        fSortNap := 1;
        fSortCol := 2;
      end;

      Self.Sort;
   end;



end;



end;




//HHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHHH On Drop
procedure TkuShellListView.OnDrop_LVS(Sender: TObject);
var i: integer;
begin

if Assigned(fOnDrop) then fOnDrop(Sender); //  LVS.OnDrop


if fPath = '' then exit;


if ShiftDown and AltDown then exit;



// 
if not ShiftDown and not AltDown
then
begin
  if not FilesShellOperations(fkuDrop_LVS.Files, fPath, FO_COPY, 0)
  then yy(Self.Name + ' Drop', 'Drop cancel');

  Self.Reload;
  exit;
end;




//  Alt
if AltDown
then
begin
//  yy(Files.Text, ' ');

  for i := 0 to fkuDrop_LVS.Files.Count - 1
  do Lnk_Create( fkuDrop_LVS.Files[i], Self.Path);

  Self.Reload;
  exit;
end;




// Shift
if ShiftDown
then
begin
//  if yn('   :       .'+az+az+' ?') then
  if not FilesShellOperations(fkuDrop_LVS.Files, fPath, FO_MOVE, 0)
  then yy(Self.Name + ' Drop', ' ');

  Self.Reload;
  exit;
end;


end;




{$ENDREGION}





{$REGION '   Mouse   '}



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Mouse Down
procedure TkuShellListView.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var  xItem: TListItem;
begin

xItem := Self.GetItemAt(X, Y);

if xItem = nil then exit;

if Button = mbMiddle
then
begin
    Self.Selected := nil;
    Self.Selected := xItem;
    Self.SetFocus;

    xItem.Selected := true;
    xItem.MakeVisible(True);
    xItem.Focused := True;
end;



inherited;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ L Down Msg
procedure TkuShellListView.MOUSE_L_DOWN(Var Msg: TMessage);
var
  P: TPoint;

begin

P := ScreenToClient(Mouse.CursorPos);

//kuDrag:     
_kuDragPointDn := True;
_kuDragPoint1.X := P.X;
_kuDragPoint1.Y := P.Y;

inherited;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ R Down Msg
procedure TkuShellListView.MOUSE_R_DOWN(Var Msg: TMessage);
//     MouseDown      
var
  P: TPoint;
  xItem: TListItem;

begin


Self.SetFocus;

P := ScreenToClient(Mouse.CursorPos);

xItem := GetItemAt(P.X, P.Y);

if xItem = nil

then
begin
    Self.Selected := nil;
//    yy('nil');
end

else
begin
    if not xItem.Selected
    then
    begin
        Self.Selected := nil;
        Self.Selected := xItem;

        xItem.Selected := true;
        xItem.MakeVisible(True);
        xItem.Focused := True;

        Self.SetFocus;
    end;

    if (Self.PopupMenu <> nil) and (not hWheelis) then Self.PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
end;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Wheel
procedure TkuShellListView.WMMOUSEWHEEL(Var Msg: TWMMOUSEWHEEL);
begin


if KeyDownly(VK_RBUTTON)

then
begin
    hWheelis := True;
//    yy('yyyyyyyyyyyy');


    if Msg.WheelDelta > 0
    then Self.StyleNext
    else Self.StylePrev
end

else inherited;

end;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Move (Drag)
procedure TkuShellListView.MouseMove(Shift: TShiftState; X, Y: Integer);
begin

if not kuDragCan(Shift, X, Y) then exit;

Self.SelectedList(qSelectedList);

//Application.MainForm.Caption := Application.MainForm.Caption + 'O';

kuDragDo(Self, fPath, qSelectedList, False, True);


end;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Dbl Click
procedure TkuShellListView.DblClick;
begin

inherited;

Self.Execute;

end;





{$ENDREGION}





{$REGION '   set   '}


//------------------------------------------------------------------------------ Set ViewStyle
procedure TkuShellListView.SetViewStyle(Value: TViewStyle);
begin


if Assigned(fOnStyleChange) then fOnStyleChange(Value);
inherited;

end;
  

//============================================================================== Set Path
procedure TkuShellListView.SetPath(Value: string);
var
  CanSetPath: Boolean;
  t, s: string;
  
begin


CanSetPath := True;
  
if Assigned(fOnPathChange) then fOnPathChange(Self, fPath, Value, CanSetPath);

if not CanSetPath then exit;

if not kuDirectoryExists(Value, s) then exit;

if fPathRoot <> ''
  then
  if not Path_IsIn(fPathRoot, Value, t) then
  begin
  //  yy('  ');
    exit;
  end;

if fClearView
then
begin
  Self.Clear;
  exit;
end;

fPath := LV_Load(Self, s, fShowHide, fShowElements);
Self.Sort;

if Assigned(fOnPathChanged) then fOnPathChanged(Self, fPath);
  
end;


//============================================================================== Set Dir Up Item
procedure TkuShellListView.SetColoredEvenItems(Value: Boolean);
begin

//Self.fColoredEvenItems := Value;

end;


//============================================================================== Clear View;
procedure TkuShellListView.SetClearView(Value: Boolean);
begin

fClearView := Value;

if Value
then Self.Clear
else Self.Reload;

end;



//============================================================================== Set Dir Up Item
procedure TkuShellListView.SetDirUpItem(Value: Boolean);
begin

Self.fDirUpItem := Value;
  
end;



//============================================================================== Set Execute (On DblClick)
procedure TkuShellListView.SetExecuteFile(Value: Boolean);
begin

Self.fExecuteFile := Value;

end;



//============================================================================== Set Execute (On DblClick)
procedure TkuShellListView.SetPathRoot(Value: string);
var
le_path, le_value : integer;
s: string;


begin

//  FixRoot     fPath    FixRoot
//  Path := FixRoot

if Value = ''
then
begin
//     yy(' FixRoot');

     Self.fPathRoot := Value;
     Self.Path := Value;
//     Self.Reload;
     exit;
end;


Value := ExcludeTrailingBackslash(Value);

if Path_IsIn(Value, fPath, s)

then Self.fPathRoot := Value

else
begin
//     yy(' FixRoot');

     Self.fPathRoot := Value;
     Self.fPath := Value;
     Self.Reload;
end;

end;



//============================================================================== Set Show Hide
procedure TkuShellListView.SetShowHide(Value: Boolean);
begin
  
Self.fShowHide := Value;
Self.Reload;
  
end;
  


//============================================================================== Set Show Elements
procedure TkuShellListView.SetShowElements(Value: TShowElements);
begin
  
fShowElements := Value;
Self.Reload;
  
end;
  
  
  
{$ENDREGION}





{$REGION '   fx   '}


//------------------------------------------------------------------------------ Execute
procedure TkuShellListView.Execute;
var FullPath: string;


begin

if Self.Selected = nil then exit;


FullPath := Self.TeloName(Self.Selected.Index, fPath);


if LVS_isFolder( Self.Selected.SubItems[0] )

then//Folder
begin
//    yy(FullPath, '');
    SetPath(FullPath);
end

else//File
begin

    if Self.Selected.SubItems.Strings[0] = 'lnk'

    then
    begin
    //    yy(FullPath, '');
        FullPath := Lnk_GetPath(Self.TeloName(Self.Selected.Index, Self.Path));

        if directoryExists(FullPath)
        then
        begin
            SetPath(FullPath);
            exit;
        end;

        if  FileExists(FullPath)
        then
        begin
            if fExecuteFile
            then
            begin
                Link_Execute1(FullPath);
                exit;
            end;
        end;

        yy('   ');

    end

    else
    begin
//        yy(FullPath, '');
        if fExecuteFile then Link_Execute1(FullPath);
    end;
end;

end;



//------------------------------------------------------------------------------ Rename
procedure TkuShellListView.Rename;
var
  OldExtOnly, OldNameOnly, OldTelo, NewName, NewExt, NewTelo : string;

begin

if Self.Selected = nil then exit;
if fPath = '' then exit;


OldNameOnly := Self.Selected.Caption;
OldExtOnly  := Self.Selected.SubItems.Strings[0];

if LVS_isFolder(OldExtOnly)

then OldTelo := OldNameOnly

else
begin
     if OldExtOnly = ''
     then OldTelo := OldNameOnly
     else OldTelo := OldNameOnly +'.'+ OldExtOnly;
end;

if not ReNamer( _Rename, OldTelo, NewTelo, 0,  Length(OldNameOnly)  ) then exit;

if OldTelo = NewTelo then exit;


if LVS_isFolder(OldExtOnly)

then
begin
    NewName := NewTelo;
    NewExt  := LVS_DIR_EXT
end

else
begin
    NewName := File_NameOnly(NewTelo);
    NewExt  := File_ExtOnly(NewTelo);
end;



if not FilesShellOperations
(
IncludeTrailingBackSlash(Path) + OldTelo,
IncludeTrailingBackSlash(Path) + NewTelo,
FO_RENAME, FOF_NOCONFIRMATION
)
then exit;

//Name in ListView
Self.Selected.Caption := NewName;

//Ext in ListView
Self.Selected.SubItems.Strings[0] := NewExt;

//ico
Self.Selected.ImageIndex := Shell_ico_Index( IncludeTrailingBackSlash(Path)+ NewTelo);

Self.Sort;

end;



//------------------------------------------------------------------------------ Delete
procedure TkuShellListView.DeleteSelected;
var s: string;
begin

if Self.Selected = nil then exit;
if fPath = '' then exit;

Self.SelectedList(qSelectedList, fPath);

if FilesShellOperations( qSelectedList, '!', FO_DELETE, FOF_ALLOWUNDO )
then
begin
   inherited;
end;

end;



//------------------------------------------------------------------------------ Create New Folder
procedure TkuShellListView.CreateNewFolder;

var
Item: TListItem;
NewName, NewPath, t: string;


begin

if fPath = '' then exit;


if Self.Selected <> nil
then t := Self.Selected.Caption
else t := _lvs_NewFolderName;



while True
do
begin
      if not ReNamer(_lvs_CreateNewFolder, t, NewName) then exit;

      NewPath := IncludeTrailingBackSlash(Path) + NewName;

      if DirectoryExists(NewPath)
      then//   
      begin
           YY(NewName +#13#10#13#10+ _lvs_DirAlreadyExist);
           t := NewName;
           Continue;
      end;

      if not CreateDir(NewPath)
      then//   
      begin
            YY(_lvs_DirCanNotCreate);
            Continue;
      end;

      Break;
end;



Self.Reload;
Item := Self.FindTeloID( ExtractFileName(NewPath) +'.'+_LVS_DIR_EXTID );


{
//if Dir_HasData(Path)
//
//then
//begin
//    yy('has data///'+ _LVS_Path);
    yy('11111111');
    Item := Self.Items.Add;
    yy('2222');
//
    Item.ImageIndex := Shell_ico_Index(NewPath);  //icon
    Item.Caption := (NewName);   //Name
    Item.SubItems.Add( LVS_DIR_EXT );  //Ext
    Item.SubItems.Add( _LVS_DIR_SIZE );  //Size
    Self.Sort;
//end
//
//else//  
//begin
//    Self.Reload;
//end;
}


Self.Selected := nil;
Self.Selected := Item;
Self.ItemFocused := Item;
Self.SetFocus;


end;




//------------------------------------------------------------------------------ Create New Txt
procedure TkuShellListView.CreateNewTxt;
var
  List: TStrings;
  NewPath: string;

begin

List := TStringList.Create;

NewPath := File_NameUnikal(Self.Path, 'info.txt');

List.SaveToFile(NewPath);
Self.Reload;
Self.Selected := nil;
Self.Selected := Self.FindTeloID( ExtractFileName(NewPath) );
List.Free;

exit;

//----
//var
//  List: TStrings;
//  s, NewPath, NewName: string;
//  i: integer;
//
//NewName := 'info.txt';
//s := 'info.txt';
//while True
//do
//begin
//      if not ReNamer(_lvs_CreateNewFolder, s, NewName) then exit;
//
//      if __FastCreate
//
//      then
//      begin
//          i := 2;
//
//          while FileExists(s)
//          do
//          begin
//              NewPath := IncludeTrailingBackSlash(LVS.Path) + 'info ('+ inttostr(i) +')'+'.txt';
//              i := i + 1;
//          end;
//
//          List.SaveToFile(NewPath);
//          LVS.Reload;
//          File_Execute(NewPath);
//      end
//
//      else
//      begin
//          NewPath := IncludeTrailingBackSlash(LVS.Path) + NewName;
//
//          if FileExists(NewPath)
//          then//   txt
//          begin
//               YY(NewName +#13#10#13#10+ _lvs_DirAlreadyExist);
//               s := NewName;
//               Continue;
//          end
//
//          else
//          begin
//              List.SaveToFile(NewPath);
//              LVS.Reload;
//          end;
//      end;
//
//      Break;
//end;

end;




//------------------------------------------------------------------------------ Properties
procedure TkuShellListView.Info;
begin

if Self.Selected = nil

then
begin
  if Self.Path = '' then exit;
  File_ShellProperties( ShellSpecStr(Self.Path) )
end

else
begin
  Self.SelectedList(qSelectedList, fPath);
  File_ShellProperties( ShellSpecStr(qSelectedList) );
end;

end;




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Copy
procedure TkuShellListView.CopyData;
begin

if fPath = '' then exit;

Self.SelectedList(qSelectedList, fPath);

Clipboard_Send(qSelectedList, stCopy);

end;


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Cut
procedure TkuShellListView.CutData;
begin

if fPath = '' then exit;

Self.SelectedList(qSelectedList, fPath);

Clipboard_Send(qSelectedList, stCut);

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Paste
procedure TkuShellListView.PasteData;
begin

if fPath = '' then exit;
ClipBoard_Paste( fPath );
Self.Reload;

end;


//------------------------------------------------------------------------------ DirUp
procedure TkuShellListView.DirUp;
var
  i : integer;
  s, FolName : string;

begin

if fPath = '' then exit;

if not DirectoryExists(fPath) then exit;

s := Path_DirUp(fPath, FolName);

Self.Path := s;

//Select
if fPath = s
then
begin
  Self.Selected := Items_Find(Self.Items, FolName);
  Self.ItemFocused := Self.Selected;
end;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Prev
procedure TkuShellListView.StylePrev;
begin

case Self.ViewStyle
of
  vsReport:    Self.ViewStyle := vsSmallIcon;
  vsIcon:      Self.ViewStyle := vsReport;
  vsList:      Self.ViewStyle := vsIcon;
  vsSmallIcon: Self.ViewStyle := vsList;
end;

Self.Reload;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Style Next
procedure TkuShellListView.StyleNext;
begin

case Self.ViewStyle
of
  vsReport:    Self.ViewStyle := vsIcon;
  vsIcon:      Self.ViewStyle := vsList;
  vsList:      Self.ViewStyle := vsSmallIcon;
  vsSmallIcon: Self.ViewStyle := vsReport;
end;

Self.Reload;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Reload
procedure TkuShellListView.Reload;
var
  i: integer;
  iItem: TListItem;
  SelectAfter: Boolean;


begin

if fClearView
then
begin
  Self.Clear;
  exit;
end;


SelectAfter := False;

if Self.Selected <> nil
then
begin
  SelectAfter := True;
  Self.SelectedListID(qSelectedList);
end;



LV_Load(Self, fPath, fShowHide, fShowElements);
Self.Sort;


//HistoryDir <--->
//if _LVS_DirHistory = nil
//then _LVS_History := TStringList.Create;
//
//if _LVS_HistoryIndex = _LVS_History.Count - 1 then

//if _LVS_HistoryIndex <> 0
//then if IncludeTrailingBackslash(ExtractFilePath(Dir)) = _LVS_History[_LVS_HistoryIndex - 1]
//then _LVS_HistoryIndex := _LVS_HistoryIndex - 1
//else _LVS_History.Append(Dir);



if SelectAfter then

  for i := 0 to qSelectedList.Count - 1
  do
  begin
    iItem := Self.FindTeloID(qSelectedList[i]);
    if iItem <> nil then iItem.Selected := True
  end;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Open in Explorer
procedure TkuShellListView.OpenInExplorer;
var
  NameOnly, pExtOnly, SpecStr: string;
  TempList: TStrings;
  s: string;

begin

if fPath = ''
then//  " "
begin
    ShellExecute(Handle, nil, '::{20D04FE0-3AEA-1069-A2D8-08002B30309D}', nil, nil, SW_SHOWNORMAL);
    exit;
end;


if not DirectoryExists(fPath) then exit;

if Self.SelCount = 1

then
begin
    s := Self.TeloName(Self.Selected.Index, fPath);

    if FileExists(s) or DirectoryExists(s)
    then Link_FolderOpenAndFileSelect(s)
    else Link_Execute(fPath);
end

else Link_Execute(fPath);


exit;


if Self.Selected = nil
then
begin
    Link_Execute(IncludeTrailingBackSlash(Path));
end

else
begin
    NameOnly  := Self.Items.Item[Self.Selected.Index].Caption;
    pExtOnly  := '.' + Self.Items.Item[Self.Selected.Index].SubItems.Strings[0];
    TempList.Delimiter := '_';
    TempList.QuoteChar := '"';
    SpecStr := TempList.DelimitedText;
    yy(SpecStr);
    Link_FolderOpenAndFileSelect(IncludeTrailingBackSlash(Path) + NameOnly + pExtOnly);
end;


end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Post Fix Root
function TkuShellListView.PostRootPath: string;
//    Root
var leFixRoot, lePath: integer;

begin

leFixRoot := Length(fPathRoot);
lePath    := Length( ExcludeTrailingBackslash(fPath) );


Result := copy(fPath, leFixRoot + 1, lePath);

end;



{$ENDREGION}






{$REGION '   Sort   '}




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Col Click
procedure TkuShellListView.ColClick(Column: TListColumn);
{
1  -  
-1 - 
}
begin

if Column.Index = fSortCol
then fSortNap := -fSortNap
else fSortCol := Column.Index;

Self.Sort;

end;

   


{$REGION '   sort rules   '}



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD FF
function Sort_FF(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin//      
    
Result := 0;

if LVS_isFolder( Item1.SubItems[0] )

then Result := -ParamSort

else if  LVS_isFolder( Item2.SubItems[0] )
     then Result := ParamSort;
    
end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Name
function Sort_Name(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin
    
Result := 0;

//if AnsiUpperCase( Item1.Caption ) = AnsiUpperCase( Item2.Caption ) then exit;

if AnsiUpperCase( Item1.Caption ) > AnsiUpperCase( Item2.Caption )
then Result := ParamSort
else if AnsiUpperCase( Item1.Caption ) < AnsiUpperCase( Item2.Caption )
     then Result := -ParamSort;
    
end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Ext
function Sort_Ext(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin
    
Result := 0;

//if AnsiUpperCase( Item1.Caption ) = AnsiUpperCase( Item2.Caption ) then exit;

if AnsiUpperCase( Item1.SubItems[0] ) > AnsiUpperCase( Item2.SubItems[0] )
then Result := ParamSort
    
else
   if AnsiUpperCase( Item1.SubItems[0] ) < AnsiUpperCase( Item2.SubItems[0] )
   then Result := -ParamSort;
end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD ABC
function Sort_SizeAsABC(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin
    
Result := 0;

//if AnsiUpperCase( Item1.Caption ) = AnsiUpperCase( Item2.Caption ) then exit;

if LVS_isFolder(Item1.SubItems[0]) or  LVS_isFolder(Item2.SubItems[0])
then
begin
//  Result := ParamSort;
  exit;
end;


if Item1.SubItems[1] > Item2.SubItems[1]
then Result := ParamSort
else if Item1.SubItems[1] < Item2.SubItems[1]
     then  Result := -ParamSort;
end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Num
function Sort_SizeAsNUM(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
begin

Result := 0;

//if not Str_FromNabor(Item1.SubItems[1], '0123456789') then exit;
//if not Str_FromNabor(Item2.SubItems[1], '0123456789') then exit;

if  LVS_isFolder(Item1.SubItems[0]) or  LVS_isFolder(Item2.SubItems[0]) then exit;

//..     LVS     

if StrToInt(Item1.SubItems[1]) > StrToInt(Item2.SubItems[1])
    
then Result := ParamSort
    
else if StrToInt(Item1.SubItems[1]) < StrToInt(Item2.SubItems[1])
     then Result := -ParamSort;

end;



//DDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDDD Size Format
function Sort_SizeFormat(Item1, Item2: TListItem; ParamSort: integer): integer; stdcall;
var
i1, i2: integer;


  function subSizeFormatToInt(const SizeFormat: string): integer;
  begin
      if Pos(' byte', SizeFormat) <> 0
        then Result := 0 //byte
        else
        begin
          if Pos(' Mb', SizeFormat) <> 0
            then Result := 1 //Mb
            else Result := 2 //Gb
        end;
  end;


begin

Result := 0;

if LVS_isFolder(Item1) or LVS_isFolder(Item2) then exit;


i1 := subSizeFormatToInt(Item1.SubItems[1]);
i2 := subSizeFormatToInt(Item2.SubItems[1]);


if i1 = i2
then
begin
  i1 := File_Size(   TkuShellListView(Item1.ListView).TeloNameB(Item1, true)  );
  i2 := File_Size(   TkuShellListView(Item1.ListView).TeloNameB(Item2, true)  );
end;


if i1 > i2

then Result := ParamSort

else
//if i1 < i2 then
     Result := -ParamSort;

end;



{$ENDREGION}





//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Sort()
procedure TkuShellListView.Sort(SortCol, SortNap: integer);
//    
begin

if (SortCol < 0) or (SortCol > 3) then exit;
if (SortNap <> 1) and (SortNap <> -1) then exit;


Self.Items.BeginUpdate;

fSortCol := SortCol;
fSortNap := SortNap;


//by Name
if SortCol = 0
then
begin
    Self.CustomSort(@Sort_Name, SortNap);
end;

    
//by Ext
if SortCol = 1
then
begin
     Self.CustomSort(@Sort_Name, SortNap);
     Self.CustomSort(@Sort_Ext,  SortNap);
end;
    
    
//by Size
if SortCol = 2
then
begin
     Self.CustomSort(@Sort_Name, SortNap);
     Self.CustomSort(@Sort_SizeFormat,  SortNap);
end;
    
    
Self.CustomSort(@Sort_FF,  1);

Self.Items.EndUpdate;

end;



//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ Sort
procedure TkuShellListView.Sort;
begin

Self.Sort(fSortCol, fSortNap);

end;





{$ENDREGION}





{$REGION ' ini '}
  
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ini Load
procedure TkuShellListView.iniLoad(SectionName: string = ''; LoadPath: Boolean = False);
//   ini :       
var
  ini: TIniFile;
  i, j, needpos: integer;
  s: string;
  
  
begin

s := Path_App + _setini;

if not FileExists(s) then exit;

if SectionName = '' then SectionName := Self.Name;

ini := TiniFile.Create(s);

try
  
//View Style
i := ini.ReadInteger(SectionName, 'Style', LV_StyleToInt(Self));
case i
of
  0: Self.ViewStyle := vsReport;
  1: Self.ViewStyle := vsIcon;
  2: Self.ViewStyle := vsList;
  3: Self.ViewStyle := vsSmallIcon;
end;


//Col widths
i := Self.Width - Self.Column[1].Width - Self.Column[2].Width - 60;
Self.Column[0].Width := ini.ReadInteger ( SectionName, 'KolWidth0', i  );
Self.Column[1].Width := ini.ReadInteger ( SectionName, 'KolWidth1', 80   );
Self.Column[2].Width := ini.ReadInteger ( SectionName, 'KolWidth2', 80   );

  
//Sort
i := ini.ReadInteger ( SectionName, 'SortCol', 1);
j := ini.ReadInteger ( SectionName, 'SortNap', 1);
Self.Sort(i, j);
  
  
//Path
if LoadPath
then
begin
  s := ini.ReadString(SectionName, 'Path', '');
  if DirectoryExists(s)
  then Self.SetPath(s)
  else Self.Path := '';
end;

//Hide
Self.ShowHide := ini.ReadBool ( SectionName, 'ShowHide', false );
  
  
  
  
//Col pos
//iCol := 0;
//needpos := ini.ReadInteger(SectionName, 'LVS_KolPos_0', 0);
//LV.Column[iCol].Index := needpos;
////if needpos < iCol then i := -1;
//if needpos > iCol then i := 1;
//if needpos = iCol then i := 0;
//
//iCol := 1;
//needpos := ini.ReadInteger(SectionName, 'LVS_KolPos_1', 0);
//LV.Column[iCol - i].Index := needpos;
//if needpos < iCol - i then i := -1;
//if needpos > iCol - i then i := 1;
//if needpos = iCol - i then i := 0;
//
//
//iCol := 2;
//needpos := ini.ReadInteger(SectionName, 'LVS_KolPos_1', 0);
//if needpos < iCol - i then i := -1;
//if needpos > iCol - i then i := 1;
//if needpos = iCol - i then i := 0;
//LV.Column[iCol - i].Index := needpos;
  
  
finally
      ini.Free;
end;
                
end;
  
  
  
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ ini Save
procedure TkuShellListView.iniSave(const SectionName: string);
//   ini :       
var
ini : TIniFile;
i: integer;
  
begin

ini := TiniFile.Create( Path_App + _setini );
    
try

i := LV_StyleToInt(Self);
  
ini.WriteInteger ( SectionName, 'Style', i );
  
//width
ini.WriteInteger ( SectionName, 'KolWidth0',   Self.Column[0].Width );
ini.WriteInteger ( SectionName, 'KolWidth1',   Self.Column[1].Width );
ini.WriteInteger ( SectionName, 'KolWidth2',   Self.Column[2].Width );
  
  
//Sort
ini.WriteInteger ( SectionName, 'SortCol', fSortCol );
ini.WriteInteger ( SectionName, 'SortNap', fSortNap );
  

//Path
ini.WriteString ( SectionName, 'Path', fPath );


//Hide
ini.WriteBool ( SectionName, 'ShowHide', fShowHide );
  
//pos
//ini.WriteInteger( SectionName, 'LVS_KolPos_0',      LV.Column[0].id    );
//ini.WriteInteger( SectionName, 'LVS_KolPos_1',      LV.Column[1].id    );
//ini.WriteInteger( SectionName, 'LVS_KolPos_2',      LV.Column[2].id    );
  
finally
      ini.Free;
end;
    
end;
  
  
{$ENDREGION}





{$REGION '   Telo. Name. Path   '}



//============================================================================== Telo ID
function TkuShellListView.TeloID(Index: integer; AddFullPath: string = ''): string;
//   lvs-   Index
// FullPath=True,     Index
begin

if LVS_isFolder( Self.Items[Index].SubItems[0] )
then Result := Self.Items[Index].Caption +'.'+ _LVS_DIR_EXTID
else Result := Self.Items[Index].Caption +'.'+ Self.Items[Index].SubItems[0];

if AddFullPath <> ''
then Result := IncludeTrailingBackSlash(AddFullPath) + Result;

end;




//============================================================================== Telo Name (Item)
function TkuShellListView.TeloNameI(Item: TListItem; AddFullPath: string = ''): string; //overload;
//   Index
//:   
//:   
//:    .lnk
//...
//AddFullPath -   Result,       Index
begin

if Item = nil
then
begin
    Result := '';
    yy('function TeloName ---> Item = nil');
    exit;
end;


if LVS_isFolder(Item)
then Result := Item.Caption
else Result := Item.Caption +'.'+ Item.SubItems[0];


if AddFullPath <> ''
then Result := IncludeTrailingBackSlash(AddFullPath) + Result;


end;




//============================================================================== Telo Name (Index)
function TkuShellListView.TeloName(Index: integer; AddFullPath: string = ''): string; //overload;
begin

Result := Self.TeloNameI(Self.Items[Index], AddFullPath);

end;




//============================================================================== Telo Name (Boolean)
function TkuShellListView.TeloNameB(Item: TListItem; AddFullPath: Boolean): string; //overload;
begin

if AddFullPath
then Result := Self.TeloNameI(Item, fPath)
else Result := Self.TeloNameI(Item);

end;









//============================================================================== Selected List
procedure TkuShellListView.SelectedList(Strs: TStrings; AddFullPath: string = '');
var i: integer;

begin

Strs.Clear;

if Self.SelCount = 0
then
begin
//    Y_('selected', '   !' );
    exit;
end;


//Result.Capacity := Self.SelCount;


for i := 0 to Self.Items.Count - 1
do
begin
     if Self.Items[i].Selected
     then Strs.Append( Self.TeloName(i, AddFullPath) );
end;


end;


//============================================================================== Selected List ID
procedure TkuShellListView.SelectedListID(Strs: TStrings; AddFullPath: string = '');
var i: integer;

begin

Strs.Clear;

if Self.SelCount = 0
then
begin
//    Y_('selected', '   !' );
    exit;
end;



for i := 0 to Self.Items.Count - 1
do
begin
  if Self.Items[i].Selected
  then Strs.Append( Self.TeloID(i, AddFullPath) );
end;


end;





//============================================================================== Select Invers
procedure TkuShellListView.SelectInvers;
begin
Items_SelectInvers(Self.Items);
end;


//============================================================================== Deselect All
procedure TkuShellListView.DeselectAll;
begin
Selected := nil;
end;





//============================================================================== Find
function TkuShellListView.FindTeloID(TeloID: string): TListItem;
//  ListViewShell
//TeloID -  Name.ext

// = Name.Ext
// = Name.*dir -     _LVS_DIR_EXTID  !
//...
//...
var
  i : integer;
  oName, oExt: string;

begin

Result := nil;


oExt  := File_ExtOnly(TeloID);
oName := copy( TeloID, 1, Length(TeloID) - Length(oExt) - 1 );

if oExt = _LVS_DIR_EXTID then oExt := LVS_DIR_EXT;


//yy(oName + #10#13+ oext, 'LVS_FindTeloID');


for i := 0 to Self.Items.Count - 1
do
begin
//    yy(LV.Items.Item[i].Caption +#10#13+ oName);

    if Self.Items[i].Caption = oName
    then
    begin
//         yy('name fiede');

         if Self.Items[i].SubItems[0] = oExt
         then
         begin
            Result := Self.Items[i];
            exit;
         end;
    end;
end;


end;



//------------------------------------------------------------------------------ Directory Exists
function kuDirectoryExists(Path: string; var PathReform: string; CanRoot: Boolean = True): Boolean;
{
      LVS
       
CanRoot -   Root(my Comp)  Path = '';
}


begin

Result := False;

if Path = ''
then
begin
    if not CanRoot then exit;
    PathReform := '';
    Result := True;
    exit;
end;


PathReform := Path_RelativToFull(Path);
Result := DirectoryExists(PathReform);

end;




{$ENDREGION}





{$REGION '   LVS uni  '}

//============================================================================== Style To Int
function LV_StyleToInt(LV: TListView): integer;
begin

Result := 0;

case LV.ViewStyle
of
  vsReport:     Result := 0; //Table
  vsIcon:       Result := 1; //Icons
  vsList:       Result := 2; //Cols
  vsSmallIcon:  Result := 3; //Rows
end;

end;



//============================================================================== Colored Even
procedure LV_ColoredEvenItems(LV: TListView; Item: TListItem; EvenColor: TColor = -1);
begin

if Item = nil then exit;

if LV.ViewStyle <> vsReport then exit;


if not isEvent(Item.Index)
then// 
    if EvenColor = -1
    then LV.Canvas.Brush.Color := cl_Darker(LV.Canvas.Brush.Color, 3)
    else LV.Canvas.Brush.Color := EvenColor;


end;



//============================================================================== isFolder
function LVS_isFolder(ext: string): Boolean; overload;
begin

Result := False;

if ext = '' then exit;

if ext[1] = _LVS_DIR_EXT_PREFIX
then Result := true;

end;



//============================================================================== isFolder
function LVS_isFolder(Item: TListItem): Boolean; overload;
begin

Result := LVS_isFolder( Item.SubItems[0] );

end;



//==============================================================================  Adres_Enter
procedure Adres_Enter(Adres: TEdit; LVS: TkuShellListView);
var s: string;

begin

//if key = 13
//then
  if Adres.Text <> LVS.Path
      then
      begin
         if kuDirectoryExists(Adres.Text, s, False)

         then
         begin
            LVS.Path := s;
//            LVS.SetFocus;
         end

         else
         begin
            Adres.Text := LVS.Path;
            Adres.SelStart := length(Adres.Text);
            Adres.SelectAll;
         end;

//         Form1.Caption := Form1.Caption + '|';
      end;


end;





//============================================================================== DIR_EXT
function LVS_DIR_EXT: string;
//     ""  : \Folder
begin

Result := _LVS_DIR_EXT_PREFIX + _LVS_DIR_EXT_POSTFIX;

end;




//============================================================================== Load Root
procedure LV_LoadRoot(LV: TListView; ReadOnlyDrives: Boolean = False);
var
  c: char;
  s: string;
//  node: TTreeNode;
  DriveType: integer;
  xItem: TListItem;

begin
LV.Items.BeginUpdate;

LV.Items.Clear;

//TV.StateImages := icoList;
//TV.Images := icoList;
Shell_ico_LoadAll(LV.SmallImages as TImageList, True);
Shell_ico_LoadAll(LV.LargeImages as TImageList, False);

for c := 'A' to 'Z'
do
begin
  s := c + ':';

  DriveType := GetDriveType(PChar(s));

  if DriveType = 1 then continue;

  if (DriveType <> DRIVE_FIXED) and (DriveType <> DRIVE_REMOVABLE) and ReadOnlyDrives then continue;

  xItem := LV.Items.Add;
  xItem.caption := s;
  xItem.SubItems.Add(LVS_DIR_EXT);  //Ext
  xItem.SubItems.Add(_LVS_DIR_SIZE); //Size
  xItem.ImageIndex := Shell_ico_Index(s);
end;
        

LV.Items.EndUpdate;
end;




//============================================================================== Load Dir
function LV_LoadDir(LV: TListView; Dir: string; HideShow: Boolean; ShowType: TShowElements): Boolean;
// ListView  
var
  sr: TSearchRec;
  xItem: TListItem;
  icoListSmall, icoListLarge: TImageList;
  Atrib: integer;

begin

Result := False;

if Length(Dir) = 1
then Dir := Dir + ':\'
else if Dir[Length(Dir)] <> '\' then Dir := Dir + '\';

if not DirectoryExists(Dir) then exit;


if HideShow
then Atrib := faDirectory + faAnyFile + faVolumeID
else Atrib := faDirectory + faAnyFile + faVolumeID - faHidden - faSysFile;

if FindFirst(Dir + '*.*', Atrib, sr) <> 0
then
begin
// yy('   !   !');
 exit;
end;

Result := True;


LV.Cursor := crHourGlass;

LV.Items.BeginUpdate;



//     
if LV.SmallImages = nil

then
begin
  icoListSmall := TImageList.Create(LV.Owner);
  LV.SmallImages := icoListSmall;
end

else  icoListSmall := LV.SmallImages as TImageList;


//     
if LV.LargeImages = nil

then
begin
  icoListLarge := TImageList.Create(LV.Owner);
  LV.LargeImages := icoListLarge;
end

else  icoListLarge := LV.LargeImages as TImageList;





Shell_ico_LoadAll(LV.SmallImages as TImageList, True);
Shell_ico_LoadAll(LV.LargeImages as TImageList, False);

LV.Items.Clear;
  
repeat
      if sr.Name = ''   then Continue;
      if sr.Name = '.'  then Continue;
      if sr.Name = '..' then Continue;

      if sr.Attr and faDirectory = faDirectory

      then//
      begin
          if (ShowType = seAll) or (ShowType = seFolders)
          then
          begin
              xItem := LV.Items.Add;
              xItem.ImageIndex := Shell_ico_Index(Dir + sr.Name); //ico
              xItem.Caption := (sr.Name);        //Name
              xItem.SubItems.Add(LVS_DIR_EXT);   //Ext
              xItem.SubItems.Add(_LVS_DIR_SIZE); //Size
          end;
      end

      else//
      begin
          if (ShowType = seAll) or (ShowType = seFiles)
          then
          begin
              xItem := LV.Items.Add;
              xItem.ImageIndex := Shell_ico_Index(Dir + sr.Name); //ico
              xItem.Caption := File_NameOnly(sr.Name);       //Name
              xItem.SubItems.Add( File_ExtOnly(sr.Name) );   //Ext
              xItem.SubItems.Add( DataSizeFormat(sr.Size) ); //Size format
          end;
      end;


//      if (sr.Attr and faHidden = faHidden) or (sr.Attr and faSysFile = faSysFile)
//      then
//      begin
//         xItem
//      end;

  
until FindNext(sr) <> 0;

FindClose(sr);

LV.Items.EndUpdate;

LV.Cursor := crDefault;
end;




//============================================================================== Load
function LV_Load(LV: TListView; Dir: string; HideShow: Boolean; ShowType: TShowElements): string;
var s, t: string;

begin

s := Dir;

if Dir = ''

then LV_LoadRoot(LV)

else  if not LV_LoadDir(LV, Dir, HideShow, ShowType)
      then
      begin
         s := Path_DirUp(Dir, t);
         LV_Load(LV, s, HideShow, ShowType);
      end;

Result := s;
// !!!!

end;







{$ENDREGION}





{$REGION '       '}




{$REGION '   ~ execute via command line   '}


function ExecCommandLine1(CommandLine: string): TProcessInformation;
var StartUpInfos: TStartUpInfo;
begin
  StartUpInfos.cb:= SizeOf(StartUpInfos);
  StartUpInfos.lpReserved:= nil;
  StartUpInfos.lpDesktop:= nil;
  StartUpInfos.lpTitle:= nil;
  StartUpInfos.dwFlags:= 0;
  StartUpInfos.cbReserved2:= 0;
  StartUpInfos.lpReserved2:= nil;
  CreateProcess(nil, PChar(CommandLine), nil, nil,
    False, CREATE_DEFAULT_ERROR_MODE + CREATE_NEW_CONSOLE +
NORMAL_PRIORITY_CLASS,
    nil, nil, StartUpInfos, Result);
end;


function ExecCommandLine2(CommandLine: string): integer;
var ProcessInfo: TProcessInformation; StartupInfo: TStartupInfo;
begin
ZeroMemory(@StartupInfo, SizeOf(TStartupInfo));
with StartupInfo
do
begin
cb := SizeOf(TStartupInfo);
dwFlags := STARTF_USESHOWWINDOW;
wShowWindow := SW_SHOW; //  SW_HIDE, ...
end;

if CreateProcess(nil, PChar(CommandLine), nil, nil, False, 0, nil, nil, StartupInfo, ProcessInfo)
then Result := ProcessInfo.hProcess
else Result := 0;
end;



function WinExecute(CmdLine: string; Title: string; Wait: Boolean; hide:Boolean = false): Boolean;
var
  StartupInfo: TStartupInfo;
  ProcessInformation: TProcessInformation;
begin
  Result := True;
  try
    ZeroMemory(@StartupInfo, Sizeof(StartupInfo));
    StartupInfo.cb := Sizeof(StartupInfo);
    StartupInfo.dwFlags := STARTF_USESHOWWINDOW;
  //  StartupInfo.wShowWindow := SW_NORMAL; //    
    if hide then
     Begin
      StartupInfo.wShowWindow := SW_HIDE;
     End
    else
     begin
      StartupInfo.wShowWindow := SW_SHOWNORMAL;
     end;
    StartupInfo.lpTitle := pWideChar(Title);

    if not CreateProcess(nil, PChar(CmdLine), nil, nil, TRUE, 0, nil,
    nil, StartupInfo, ProcessInformation) then
      RaiseLastWin32Error;

    if Wait then
      WaitForSingleObject(ProcessInformation.hProcess, INFINITE);
  except
    Result := False;
  end;
end;




function ExecAndWait(const ExeName, Params: string; out ExitCode: Cardinal; Timeout: Cardinal = MaxInt): boolean;
var
  sui: TStartupInfo;
  pi: TProcessInformation;
begin

ZeroMemory(@sui, SizeOf(sui));
sui.cb := SizeOf(sui);

Win32Check(
CreateProcess(PChar(ExeName), PChar(Params), nil, nil, False, 0, nil, nil, sui, pi)
);

try
  CloseHandle(pi.hThread);
  Result := WaitForSingleObject(pi.hProcess, Timeout) = WAIT_OBJECT_0;
  if Result then Win32Check(GetExitCodeProcess(pi.hProcess, ExitCode));
finally
  CloseHandle(pi.hProcess);
end;

end;

procedure ExecCommandLine(const Cmd: string);
var
  Dummy: Cardinal;
begin
  ExecAndWait(GetEnvironmentVariable('ComSpec'), '/C ' + Cmd, Dummy);
end;


{$ENDREGION}






//============================================================================== Refresh Icons
procedure LVS_RefreshIconss(LV: TListView; Dir: string);
// 
//        :(
var   
  i: integer;
  xItem: TListItem;
  icoListSmall, icoListLarge: TImageList;

begin
  
LV.Cursor := crHourGlass;

LV.Items.BeginUpdate;



//     
if LV.SmallImages = nil

then
begin
  icoListSmall := TImageList.Create(LV.Owner);
  LV.SmallImages := icoListSmall;
end

else  icoListSmall := LV.SmallImages as TImageList;


//     
if LV.LargeImages = nil

then
begin
  icoListLarge := TImageList.Create(LV.Owner);
  LV.LargeImages := icoListLarge;
end

else  icoListLarge := LV.LargeImages as TImageList;





Shell_ico_LoadAll(LV.SmallImages as TImageList, True);
Shell_ico_LoadAll(LV.LargeImages as TImageList, False);


for i := 0 to LV.Items.Count - 1
do
begin
//  LV.Items[i].ImageIndex := Shell_ico_Index(LVS_TeloName(LV, i, Dir)); //ico
//  yy(LVS_TeloName(LV, i, Dir));
end;



LV.Items.EndUpdate;

LV.Cursor := crDefault;
end;




//------------------------------------------------------------------------------ Insert Files
procedure LV_InsertFiles(LV: TListView; strPath: string; ImageList: TImageList);
var
 i: Integer;
 Icon: TIcon;
 SearchRec: TSearchRec;
 ListItem: TListItem;
 FileInfo: SHFILEINFO;
    
begin
    
// Create a temporary TIcon
Icon := TIcon.Create;
LV.Items.BeginUpdate;
    
try
   // search for the first file
  i := FindFirst(strPath + '*.*', faAnyFile, SearchRec);
    
   while i = 0
   do
   begin
         with LV
         do
         begin
               // On directories and volumes
              if ((SearchRec.Attr and FaDirectory <> FaDirectory) and  (SearchRec.Attr and FaVolumeId <> FaVolumeID))
              then
              begin
                ListItem := LV.Items.Add;
    
                //Get The DisplayName
                SHGetFileInfo(PChar(strPath + SearchRec.Name), 0, FileInfo, SizeOf(FileInfo), SHGFI_DISPLAYNAME);
    
                Listitem.Caption := FileInfo.szDisplayName;
    
                // Get The TypeName
                SHGetFileInfo(PChar(strPath + SearchRec.Name), 0, FileInfo, SizeOf(FileInfo), SHGFI_TYPENAME);
                ListItem.SubItems.Add(FileInfo.szTypeName);
    
                //Get The Icon That Represents The File
                SHGetFileInfo(PChar(strPath + SearchRec.Name), 0, FileInfo, SizeOf(FileInfo), SHGFI_ICON or SHGFI_SMALLICON);
                icon.Handle := FileInfo.hIcon;
                ListItem.ImageIndex := ImageList.AddIcon(Icon);
    
                //Destroy the Icon
                DestroyIcon(FileInfo.hIcon);
    
               end;
         end;
         i := FindNext(SearchRec);
  end;
    
finally
   Icon.Free;
   LV.Items.EndUpdate;
end;
    
    
end;


{$ENDREGION}





end.


